package provide OSM::Editor::EditWay 0.1

package require OSM::Icons

oo::class create OSM::Editor::EditWay {
    variable sqimage activesqimage selectcommand selectbutton osm canvas
    constructor {args} {
        set selectbutton 1
        set selectcommand {}

        foreach {k v} $args {
            set [string trimleft $k -] $v
        }

        set sqimage OSM::Icons::node-deselected
        set activesqimage OSM::Icons::node-selected

        global modulesd
        [dict get $modulesd Toolbar] addbutton radio mode EditWay -text Select
        # my activate
    }

    method activate {} {
        $canvas bind @@ways <ButtonPress-$selectbutton> [list [namespace which my] editway %W]
        $canvas bind @@nodes&&!@@edit <ButtonPress-$selectbutton> [list [namespace which my] printnode %W]

        $canvas bind {@@nodes&&@@edit} <B$selectbutton-Motion> \
            [list [namespace which my] movenode %W %x %y]

        $canvas bind {@@nodes&&@@edit} <ButtonRelease-$selectbutton> \
            [list [namespace which my] movenode %W %x %y; \
                  [namespace which my] commitmove %W ]
    }

    method deactivate {} {
        $canvas bind @@ways <ButtonPress-$selectbutton> {}
        $canvas bind @@nodes&&!@@edit <ButtonPress-$selectbutton> {}
        $canvas bind @@nodes&&@@edit <B$selectbutton-Motion> {}
        $canvas bind @@nodes&&@@edit <ButtonRelease-$selectbutton> {}
    }

    method printnode W {
        puts [set tags [$W gettags current]]
        lassign [split [lsearch -inline -glob [$W gettags current] @id=*] =] - id
        puts [$osm node $id get]
    }

    method editway W {
        puts [set tags [$W gettags current]]
        set result {}
        foreach tag $tags {
            ### TODO: this can and will break on values containing equal signs
            lassign [split $tag =] key value
            if {($key eq "") || ($value eq "")} continue
            dict set result $key $value
        }
        if {$selectcommand ne ""} {
            {*}$selectcommand $result
        }
        $W delete @@edit
        $W dtag @@editing @@editing
        if {![dict exist $result @id]} {
            return
        }
        $W addtag @@editing withtag current
        set i 0
        foreach {x y} [set coords [$W coords @id=[dict get $result @id]]] {
            $W create image $x $y -anchor center -tags [list @@data @@edit @@nodes @@#$i] -image $sqimage -activeimage $activesqimage
            incr i
            # add rects for each node
        }
        $W lower [$W create line $coords -tags {@@data @@edit @@ways} -fill yellow] {@@nodes&&@@edit}
    }

    method movenode {W x y} {
        $W moveto current [$W canvasx $x] [$W canvasy $y]
        lassign [split [lsearch -inline -glob [$W gettags current] @@#*] #] - n
        set coords [$W coords @@#$n]
        set n [expr {$n*2}]
        $W imove {@@edit&&@@ways} $n {*}$coords
        $W imove {@@editing} $n {*}$coords
    }

    method configure args {
        foreach {k v} $args {
            set [string trimleft $k -] $v
        }
    }

    method cget key {
        set [string trimleft $key -]
    }

    method commitmove {W} {
        # TODO: update map coords
    }
}
