package provide OSM::Editor::LoadData 0.1

oo::class create OSM::Editor::LoadData {
    variable canvas
    constructor {args} {
        set panbutton 3
        foreach {k v} $args {
            set [string trimleft $k -] $v
        }

        set f [open $file]
        puts -nonewline "parsing xml file... "
        $osm parse -channel $f
        close $f
        puts parsed.

        lassign [set bbox [$canvas bbox @@data]] left top right bottom
        set x [expr {-$left}]
        set y [expr {-$top}]
        $canvas move @@data $x $y
        # ways should be above the areas
        $canvas lower @@areas
        $canvas raise @@nodetexts
        $canvas raise @@nodes

        my zoom-to-fit

        # add default bindings
        bind $canvas <Double-$panbutton> {%W scale @@data [%W canvasx %x] [%W canvasy %y] 2.0 2.0}
        bind $canvas <ButtonPress-4> {%W scale @@data [%W canvasx %x] [%W canvasy %y] 2.0 2.0}
        bind $canvas <ButtonPress-5> {%W scale @@data [%W canvasx %x] [%W canvasy %y] 0.5 0.5}
        bind $canvas <ButtonPress-$panbutton> {%W scan mark   %x %y}
        bind $canvas <B$panbutton-Motion>     {%W scan dragto %x %y 1}
    }

    method zoom-to-fit {} {
        lassign [set bbox [$canvas bbox @@data]] left top right bottom

        # zoom the @@data layer so it fits in the view
        set scale1 [expr {([$canvas cget -width]+0.0)/(-$left+$right)}]
        set scale2 [expr {([$canvas cget -height]+0.0)/(-$top+$bottom)}]
        puts [set scale [expr {max($scale1,$scale2)}]]

        $canvas scale @@data 0 0 $scale $scale
    }
}

