package provide OSM::Editor::NewWay 0.1

package require OSM::Icons

oo::class create OSM::Editor::NewWay {
    variable sqimage activesqimage selectbutton selectcommand canvas osm currentway currentnode
    constructor {args} {
        set selectbutton 1
        set selectcommand {}

        foreach {k v} $args {
            set [string trimleft $k -] $v
        }

        set sqimage OSM::Icons::node-deselected
        set activesqimage OSM::Icons::node-selected
        set currentway {}
        set currentnode {}
        set lastnodeid 0
        set lastwayid 0
        set lastrelationid 0

        global modulesd
        [dict get $modulesd Toolbar] addbutton radio mode NewWay -text Add
        # my activate
    }

    method activate {} {
        bind $canvas <ButtonPress-$selectbutton> [list [namespace which my] addnode %W %x %y]
        $canvas bind @@nodes <ButtonPress-$selectbutton> [list [namespace which my] selectnode %W]
        $canvas bind @@nodes <Double-$selectbutton> [list [namespace which my] endway %W]

        bind $canvas <Motion> \
            [list [namespace which my] moveend %W %x %y]
    }

    method deactivate {} {
        bind $canvas <ButtonPress-$selectbutton> {}
        $canvas bind @@nodes <ButtonPress-$selectbutton> {}
        $canvas bind @@nodes <Double-$selectbutton> {}

        bind $canvas <Motion> {}
    }

    method get-new-id type {
        my variable last${type}id
        return [incr last${type}id -1]
    }

    method addnode {W x y} {
        set i [llength $currentway]
        set x [$W canvasx $x]
        set y [$W canvasy $y]
        set item [if {$currentnode ne ""} {
            lassign [$W coords $currentnode] x y
            my moveend $W $x $y
            set currentnode
        } else {
            $W create image $x $y -anchor center -tags [list @@data @@edit @@nodes] -image $sqimage -activeimage $activesqimage
        }]
        if {$i == 0} {
            $W delete [lsearch -inline -not -all [$W find withtag @@edit] $item]
            $W lower [$W create line $x $y $x $y -tags {@@data @@edit @@ways} -fill yellow] {@@nodes&&@@edit}
        } else {
            set i [expr {$i*2}]
            $W insert @@edit&&@@ways $i [list $x $y]
        }
        puts [lappend currentway $item]
        set currentnode {}
    }

    method endway W {
        my selectnode $W
        if {$currentnode in $currentway} {
            set item [$W find withtag @@edit&&@@ways]
            $W addtag @id=[my get-new-id way] withtag $item
            lassign [$osm getstyle way {}] style
            lassign $style object options tags
            $W itemconfigure $item -fill black {*}$options
            foreach tag $tags {
                $W addtag $tag withtag $item
            }
            $W dtag $item @@edit
            $W delete @@edit
            set currentnode {}
            set currentway {}
            my deactivate
            after 300 [list [namespace which my] activate]
            return
        }
    }

    method selectnode W {
        puts @@[set currentnode [$W find withtag current]]
    }

    method moveend {W x y} {
        if {[set i [llength $currentway]] == 0} {
            return
        }
        set i [expr {$i*2}]
        # $W imove @@edit&&@@ways $i [$W canvasx $x] [$W canvasy $y] --- this doesn't work as expected
        $W dchars @@edit&&@@ways $i
        $W insert @@edit&&@@ways end [list [$W canvasx $x] [$W canvasy $y]]
    }

    method configure args {
        foreach {k v} $args {
            set [string trimleft $k -] $v
        }
    }

    method cget key {
        set [string trimleft $key -]
    }

    method commitmove {W} {
        # TODO: update map coords
    }
}
