package provide OSM::Editor::Presets::BuiltIn 0.1

namespace eval OSM::Editor::Presets::Tags {
    add {
        Highways {
            Streets {
                Motorway {
                    -type       way
                    -title      {Edit motorway}
                    -tags       {highway    motorway}
                    -mandatory  {
                        {
                            -key        ref
                            -default    {}
                            -name       Reference
                        }
                    }
                    -optional   {
                        {
                            -key        layer
                            -default    {}
                            -name       Layer
                            -suggest    {-5 -4 -3 -2 -1 0 1 2 3 4 5}
                        }
                        {
                            -key        oneway
                            -default    no
                            -name       Oneway
                            -boolean    yes
                        }
                    }
                }
                {Motorway link} {
                    -type       way
                    -title      {Edit motorway link}
                    -tags       {highway    motorway_link}
                    -mandatory  {
                    }
                    -optional   {
                        {
                            -key        layer
                            -default    {}
                            -name       Layer
                            -suggest    {-5 -4 -3 -2 -1 0 1 2 3 4 5}
                        }
                        {
                            -key        oneway
                            -default    yes
                            -name       Oneway
                            -boolean    yes
                        }
                    }
                }
            }
            Ways    {
                Path    {
                    -type       way
                    -title      {Edit path}
                    -tags       {highway    path}
                    -mandatory  {
                    }
                    -optional   {
                        {
                            -key        name
                            -default    {}
                            -name       Name
                        }
                    }
                }
            }
        }
        Man-made {
            Buildings {
                Addresses {
                    -type *
                    -title      {Edit address information}
                    -tags       {}
                    -mandatory  {
                        {
                            -key        addr:housenumber
                            -default    {}
                            -name       {House number}
                        }
                    }
                    -optional   {
                        {
                            -key        addr:street
                            -default    {}
                            -name       {Street name}
                        }
                    }
                }
            }
        }
    } {
        highway=motorway      {Highways Streets   Motorway}
        highway=motorway_link {Highways Streets   {Motorway link}}
        highway=path          {Highways Ways      Path}
        addr:*=*              {Man-made Buildings Addresses}
    }
}

