package provide OSM::Editor::TagEdit 0.1

oo::class create OSM::Editor::TagEdit {
    variable canvas pane tagk tagv tags
    constructor {args} {
        global gui modulesd
        foreach {k v} $args {
            set [string trimleft $k -] $v
        }

        # 
        set pane [dict get $gui pane]
        ttk::treeview $pane.tags -columns {key value} -show headings
        $pane.tags heading key -text key
        $pane.tags heading value -text value

        pack $pane.tags -fill both -expand yes
        [dict get $modulesd EditWay] configure -selectcommand [list [namespace which my] updatetags]
        [dict get $modulesd LoadData] zoom-to-fit
        bind $pane.tags <Double-1> [list [namespace which my] edittag %x %y]
    }

    method updatetags {tags {update rewrite}} {
        if {$update eq "update"} {
            set item [$pane.tags focus]
            if {$item ne ""} {
                $pane.tags item $item -values $tags
            }
        } else {
            $pane.tags delete [$pane.tags children {}]
            foreach {key value} $tags {
                $pane.tags insert {} end -values [list $key $value]
            }
            $pane.tags insert {} end -values {{} {}}
        }
    }

    method edittag {x y} {
        puts [set values [$pane.tags item [$pane.tags identify row $x $y] -values]]
        my tagpopup .tagedit $values
    }

    method updatetag values {
        puts $values
    }

    method tagpopup {w values} {
        lassign $values tagk tagv
        toplevel $w
        ttk::label $w.l1 -text Key
        ttk::entry $w.e1 -textvariable [my varname tagk]
        ttk::label $w.l2 -text Value
        ttk::entry $w.e2 -textvariable [my varname tagv]
        grid $w.l1 -row 0 -column 0 -sticky w -padx 4 -pady 4
        grid $w.e1 -row 0 -column 1 -sticky we -padx 4 -pady 4
        grid $w.l2 -row 1 -column 0 -sticky w -padx 4 -pady 4
        grid $w.e2 -row 1 -column 1 -sticky we -padx 4 -pady 4
        grid rowconfigure $w $w.e1 -weight 1
        grid rowconfigure $w $w.e2 -weight 1
        grid columnconfigure $w $w.e1 -weight 1
        grid columnconfigure $w $w.e2 -weight 1
        ttk::frame $w.buttons
        ttk::button $w.buttons.ok -text OK -command [string map [list %W $w %my [namespace which my] %k [my varname tagk] %v [my varname tagv]] {
            wm withdraw %W
            rename %W {}
            %my updatetags [list $%k $%v] update
        }] -default active
        ttk::button $w.buttons.cancel -text Cancel -command [string map [list %W $w %values $values] {
            wm withdraw %W
            rename %W {}
            # %my updatetags [list %values]
        }]
        pack $w.buttons.cancel $w.buttons.ok -side left -padx 4
        grid $w.buttons - -row 2
        wm resizable $w 0 0
        wm withdraw $w
        update
        set x [expr {([winfo screenwidth .]-[winfo width $w])/2}]
        set y [expr {([winfo screenheight .]-[winfo height $w])/2}]
        wm geometry  $w +$x+$y
        wm transient $w .
        wm title     $w "Change tags"
        wm deiconify $w
        wm resizable $w 1 1
    }
}

