package provide OSM::Editor::Toolbar 0.1

package require OSM::Icons

oo::class create OSM::Editor::Toolbar {
    variable canvas osm toolbar deferred
    constructor {args} {
        global gui
        set selectbutton 1
        set selectcommand {}

        foreach {k v} $args {
            set [string trimleft $k -] $v
        }

        dict set gui toolbar [set toolbar [ttk::frame .toolbar -relief raised -padding 2]]
        pack $toolbar -fill y -expand yes -side left -before $canvas
        set deferred {}
    }

    method addbutton {type group module args} {
        if {$deferred ne ""} {
            {*}$deferred
            set deferred {}
        }
        my variable $group 
        my variable old$group
        global modulesd
        if {![info exists $group]} {
            set $group $module
            set old$group $module
            set deferred [list [namespace which my] handlebutton $type $group]
        }
        set options [list $toolbar.[string tolower $group$module] -style Toolbutton -width 0 -variable [my varname $group]]
        lappend options -command [list [namespace which my] handlebutton $type $group]
        switch $type {
            radio {
                lappend options -value $module
            }
            check {
                lappend options -onvalue $module -offvalue {}
            }
        }
        pack [ttk::${type}button {*}$options {*}$args] -fill x
    }

    method handlebutton {type group} {
        global modulesd
        my variable $group
        my variable old$group
        set out [dict get $modulesd [set old$group]]
        if {$out ne ""} {
            $out deactivate
        }
        set in [dict get $modulesd [set $group]]
        if {$in ne ""} {
            $in activate
        }
        set old$group [set $group]
    }
}
