# Tcl-OSM test application
# 
# work-in-progress 
#
# many things we have here need to be separated
# to become the part of Tcl-OSM itself

set run_dir [file dirname [file dirname [file normalize $argv0]]]

lappend auto_path $run_dir $run_dir/editor $run_dir/editor/modules $run_dir/api

package require OSM
package require map::slippy
package require Tk
package require Ttk

ttk::style theme use clam

# prepare the data

# prepare the canvas

set c [canvas .c]
$c configure -width 1000 -height 1000
pack $c -expand yes -fill both -side left

# style items:
# 1. what tags to glob-match
# 2. what tags not to glob-match
# 3. what style to apply: list of (object type plus options (in a single list))

# the first style rule is the default style

# pseudo-tags with % in front match object types

# needs to be rewritten to support zoom-dependent width;
# also, to support MapCSS, some features are needed

set styles {
-way {} line
-node {} {image -anchor center -image OSM::Icons::node-deselected -activeimage OSM::Icons::node-selected -textoptions {-anchor s}}
{highway *} -node {line -smooth no -width 3}
{railway *} -node {line -smooth no -width 3 -dash -}
{building *} {} {polygon -smooth no -fill brown -outline black}
{landuse *} -node {polygon -smooth no -fill gray -outline black}
{area yes} {} polygon
{landuse forest} {} {polygon -fill darkgreen}
{natural water} {} {polygon -fill darkblue}
{-node * natural tree} {} {image -image OSM::Icons::tree -activeimage OSM::Icons::tree -state normal}
{waterway *} -node {line -fill darkblue -smooth yes}
{waterway riverbank} {} polygon
{landuse grass} {} {polygon -fill green}
%line {} {+* -activefill red}
%polygon {} {+*@areas -activeoutline red}
}

wm title . "Tk OpenStreetMap editor"

set osm [OSM new canvas $c styles $styles]

# make frame for displaying some info
dict set gui pane [set pane [ttk::frame .pane -relief raised]]
pack $pane -fill y -expand yes -anchor e

foreach module {LoadData Toolbar EditWay NewWay TagEdit Presets} {
    package require OSM::Editor::$module
    dict set modulesd $module [OSM::Editor::$module new canvas $c file ../tvrdošin.osm osm $osm]
}


set arrowbitmap {#define test_width 16
#define test_height 16
static unsigned char test_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x06, 0x00, 0x0a, 0x00, 0x12, 0x00,
   0x22, 0x00, 0x42, 0x00, 0x82, 0x00, 0x02, 0x01, 0x02, 0x02, 0xc2, 0x07,
   0x4a, 0x00, 0x96, 0x00, 0x92, 0x00, 0x60, 0x00};}

set arrowimage [image create bitmap -data $arrowbitmap]
# set arrowbutton [ttk::checkbutton $toolbar.edit -style Toolbutton -image $arrowimage -width 0]

# pack $arrowbutton


